#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import User
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1181732074.2293451
__CHEETAH_genTimestamp__ = 'Wed Jun 13 10:54:34 2007'
__CHEETAH_src__ = 'prewikka/templates/MessageListing.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Apr 17 12:21:25 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class MessageListing(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def layout_start_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_start_hook at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('<form method="post" action="?">\n')
        for name, value in VFFSL(SL,"hidden_parameters",True): # generated from line 6, col 1
            write('  <input type="hidden" name="')
            _v = VFFSL(SL,"name",True) # '$name' on line 7, col 30
            if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 7, col 30.
            write('" value="')
            _v = VFFSL(SL,"value",True) # '$value' on line 7, col 44
            if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 7, col 44.
            write('"/>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def layout_end_hook(self, **KWS):



        ## CHEETAH: generated from #def layout_end_hook at line 11, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('</form>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_listing_header(self, **KWS):



        ## CHEETAH: generated from #def message_listing_header at line 18, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 17, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _v = VFFSL(SL,"message_listing_header",True) # '$message_listing_header' on line 20, col 1
        if _v is not None: write(_filter(_v, rawExpr='$message_listing_header')) # from line 20, col 1.
        write('''

<table id="message_list_result">
  ''')
        _v = VFFSL(SL,"message_fields_header",True) # '$message_fields_header' on line 23, col 3
        if _v is not None: write(_filter(_v, rawExpr='$message_fields_header')) # from line 23, col 3.
        write('\n  <tbody>\n')
        row_classes = ("table_row_even", "table_row_odd")
        cnt = 0
        write('\n')
        for message in VFFSL(SL,"messages",True): # generated from line 28, col 5
            self._CHEETAH__globalSetVars["message"] = VFFSL(SL,"message",True)
            write('        <tr class="')
            _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True) % 2] # '$row_classes[$cnt % 2]' on line 30, col 20
            if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt % 2]')) # from line 30, col 20.
            write('">\n          ')
            _v = VFFSL(SL,"message_fields",True) # '$message_fields' on line 31, col 11
            if _v is not None: write(_filter(_v, rawExpr='$message_fields')) # from line 31, col 11.
            write('\n          <td class="static_content_column">\n')
            if VFN(VFFSL(SL,"prewikka.user",True),"has",False)(User.PERM_IDMEF_ALTER): # generated from line 33, col 13
                write('              <input class="checkbox" type="checkbox" name="delete" value="')
                _v = VFFSL(SL,"message.delete",True) # '$message.delete' on line 34, col 76
                if _v is not None: write(_filter(_v, rawExpr='$message.delete')) # from line 34, col 76.
                write('"/>\n')
            else: # generated from line 35, col 6
                write('\t      &nbsp;\n')
            write('          </td>\n        </tr>\n')
            cnt += 1
        write('\n')
        if VFN(VFFSL(SL,"prewikka.user",True),"has",False)(User.PERM_IDMEF_ALTER) and VFFSL(SL,"cnt",True): # generated from line 43, col 1
            write('     <tr>\n      <td colspan="4">&nbsp;</td>\n      <td style="text-align: right;"><input type="submit" value="')
            if False:
                _("Delete")
            _v = VFFSL(SL,"_",False)("Delete") # '$_("Delete")' on line 46, col 66
            if _v is not None: write(_filter(_v, rawExpr='$_("Delete")')) # from line 46, col 66.
            write('''"/></td>
      <td class="static_content_column">
       <input class="checkbox" type="checkbox" id="allbox" onclick="checkBoxByName('delete', document.forms[0].allbox.checked);"/>
      </td>
     </tr>
    </tbody>
''')
        write('\n  </table>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def timeline_extra_content(self, **KWS):



        ## CHEETAH: generated from #def timeline_extra_content at line 62, col 3.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def menu_extra_content(self, **KWS):



        ## CHEETAH: generated from #block menu_extra_content at line 60, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('<table id="timeline">\n  ')
        _v = VFFSL(SL,"timeline_extra_content",True) # '$timeline_extra_content' on line 64, col 3
        if _v is not None: write(_filter(_v, rawExpr='$timeline_extra_content')) # from line 64, col 3.
        write('''
  
  <tr>
   <th id="timeline_step_label">''')
        if False:
            _("Period")
        _v = VFFSL(SL,"_",False)("Period") # '$_("Period")' on line 67, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Period")')) # from line 67, col 33.
        write('</th>\n   <td>\n    <input class="timeline_value" name="timeline_value" type="text" size="2" value="')
        _v = VFFSL(SL,"timeline.value",True) # '$timeline.value' on line 69, col 85
        if _v is not None: write(_filter(_v, rawExpr='$timeline.value')) # from line 69, col 85.
        write('''"/>
   </td>
   <td> 
    <select class="timeline_unit_select" name="timeline_unit">
     <option value="min" ''')
        _v = VFFSL(SL,"timeline.min_selected",True) # '$timeline.min_selected' on line 73, col 26
        if _v is not None: write(_filter(_v, rawExpr='$timeline.min_selected')) # from line 73, col 26.
        write('>')
        if False:
            _("Minutes")
        _v = VFFSL(SL,"_",False)("Minutes") # '$_("Minutes")' on line 73, col 49
        if _v is not None: write(_filter(_v, rawExpr='$_("Minutes")')) # from line 73, col 49.
        write('</option>\n     <option value="hour" ')
        _v = VFFSL(SL,"timeline.hour_selected",True) # '$timeline.hour_selected' on line 74, col 27
        if _v is not None: write(_filter(_v, rawExpr='$timeline.hour_selected')) # from line 74, col 27.
        write('>')
        if False:
            _("Hours")
        _v = VFFSL(SL,"_",False)("Hours") # '$_("Hours")' on line 74, col 51
        if _v is not None: write(_filter(_v, rawExpr='$_("Hours")')) # from line 74, col 51.
        write('</option>\n     <option value="day" ')
        _v = VFFSL(SL,"timeline.day_selected",True) # '$timeline.day_selected' on line 75, col 26
        if _v is not None: write(_filter(_v, rawExpr='$timeline.day_selected')) # from line 75, col 26.
        write('>')
        if False:
            _("Days")
        _v = VFFSL(SL,"_",False)("Days") # '$_("Days")' on line 75, col 49
        if _v is not None: write(_filter(_v, rawExpr='$_("Days")')) # from line 75, col 49.
        write('</option>\n     <option value="month" ')
        _v = VFFSL(SL,"timeline.month_selected",True) # '$timeline.month_selected' on line 76, col 28
        if _v is not None: write(_filter(_v, rawExpr='$timeline.month_selected')) # from line 76, col 28.
        write('>')
        if False:
            _("Months")
        _v = VFFSL(SL,"_",False)("Months") # '$_("Months")' on line 76, col 53
        if _v is not None: write(_filter(_v, rawExpr='$_("Months")')) # from line 76, col 53.
        write('</option>\n     <option value="year" ')
        _v = VFFSL(SL,"timeline.year_selected",True) # '$timeline.year_selected' on line 77, col 27
        if _v is not None: write(_filter(_v, rawExpr='$timeline.year_selected')) # from line 77, col 27.
        write('>')
        if False:
            _("Years")
        _v = VFFSL(SL,"_",False)("Years") # '$_("Years")' on line 77, col 51
        if _v is not None: write(_filter(_v, rawExpr='$_("Years")')) # from line 77, col 51.
        write('</option>\n     <option value="unlimited" ')
        _v = VFFSL(SL,"timeline.unlimited_selected",True) # '$timeline.unlimited_selected' on line 78, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.unlimited_selected')) # from line 78, col 32.
        write('>')
        if False:
            _("Unlimited")
        _v = VFFSL(SL,"_",False)("Unlimited") # '$_("Unlimited")' on line 78, col 61
        if _v is not None: write(_filter(_v, rawExpr='$_("Unlimited")')) # from line 78, col 61.
        write('''</option>
    </select>
   </td>
  </tr>

  <tr>
    <th id="timezone_control_label">''')
        if False:
            _("Timezone")
        _v = VFFSL(SL,"_",False)("Timezone") # '$_("Timezone")' on line 84, col 37
        if _v is not None: write(_filter(_v, rawExpr='$_("Timezone")')) # from line 84, col 37.
        write('''</th>
    <td colspan="2">
      <select class="timezone_control_select" name="timezone">
        <option value="frontend_localtime" ''')
        _v = VFFSL(SL,"timeline.frontend_localtime_selected",True) # '$timeline.frontend_localtime_selected' on line 87, col 44
        if _v is not None: write(_filter(_v, rawExpr='$timeline.frontend_localtime_selected')) # from line 87, col 44.
        write('>')
        if False:
            _("Frontend localtime")
        _v = VFFSL(SL,"_",False)("Frontend localtime") # '$_("Frontend localtime")' on line 87, col 82
        if _v is not None: write(_filter(_v, rawExpr='$_("Frontend localtime")')) # from line 87, col 82.
        write('</option>\n\t<option value="sensor_localtime" ')
        _v = VFFSL(SL,"timeline.sensor_localtime_selected",True) # '$timeline.sensor_localtime_selected' on line 88, col 35
        if _v is not None: write(_filter(_v, rawExpr='$timeline.sensor_localtime_selected')) # from line 88, col 35.
        write('>')
        if False:
            _("Sensor localtime")
        _v = VFFSL(SL,"_",False)("Sensor localtime") # '$_("Sensor localtime")' on line 88, col 71
        if _v is not None: write(_filter(_v, rawExpr='$_("Sensor localtime")')) # from line 88, col 71.
        write('</option>\n\t<option value="utc" ')
        _v = VFFSL(SL,"timeline.utc_selected",True) # '$timeline.utc_selected' on line 89, col 22
        if _v is not None: write(_filter(_v, rawExpr='$timeline.utc_selected')) # from line 89, col 22.
        write('>')
        if False:
            _("UTC")
        _v = VFFSL(SL,"_",False)("UTC") # '$_("UTC")' on line 89, col 45
        if _v is not None: write(_filter(_v, rawExpr='$_("UTC")')) # from line 89, col 45.
        write('''</option>
       </select>
     </td>
  </tr>
	
  <tr>
   <th id="timeline_limit_label">''')
        if False:
            _("Limit")
        _v = VFFSL(SL,"_",False)("Limit") # '$_("Limit")' on line 95, col 34
        if _v is not None: write(_filter(_v, rawExpr='$_("Limit")')) # from line 95, col 34.
        write('''</th>

   <td colspan="2">
    <input id="timeline_limit_value" type="text" size="2" name="limit" value="''')
        _v = VFFSL(SL,"limit",True) # '$limit' on line 98, col 79
        if _v is not None: write(_filter(_v, rawExpr='$limit')) # from line 98, col 79.
        write('''"/>
   </td>
  </tr>

  <tr style="text-align: center;">
      <td colspan=3><input type="submit" name="apply" value="''')
        if False:
            _("Apply")
        _v = VFFSL(SL,"_",False)("Apply") # '$_("Apply")' on line 103, col 62
        if _v is not None: write(_filter(_v, rawExpr='$_("Apply")')) # from line 103, col 62.
        write('" />\n      <input type="submit" name="_save" value="')
        if False:
            _("Save")
        _v = VFFSL(SL,"_",False)("Save") # '$_("Save")' on line 104, col 48
        if _v is not None: write(_filter(_v, rawExpr='$_("Save")')) # from line 104, col 48.
        write('''" /></td>
  </tr>

''')
        _orig_filter_27944379 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('\n')
        if not VFFSL(SL,"timeline.start",True): # generated from line 109, col 1
            write(' <tr><td colspan="4" class="timeline_range">Unlimited</td></tr>\n <tr><td colspan="4" class="timeline_range">-</td></tr>\n')
        else: # generated from line 112, col 1
            write(' <tr><td colspan="4" class="timeline_range">')
            _v = VFFSL(SL,"timeline.start",True) # '$timeline.start' on line 113, col 45
            if _v is not None: write(_filter(_v, rawExpr='$timeline.start')) # from line 113, col 45.
            write('</td></tr>\n <tr><td colspan="4" class="timeline_range">')
            _v = VFFSL(SL,"timeline.end",True) # '$timeline.end' on line 114, col 45
            if _v is not None: write(_filter(_v, rawExpr='$timeline.end')) # from line 114, col 45.
            write('</td></tr>\n')
        write(' <tr><td colspan="4" class="timeline_range">')
        _v = VFFSL(SL,"timeline.range_timezone",True) # '$timeline.range_timezone' on line 116, col 45
        if _v is not None: write(_filter(_v, rawExpr='$timeline.range_timezone')) # from line 116, col 45.
        write('''</td></tr>

 <tr>
  <td colspan="4" style="text-align: center;">
   <table><tr>
''')
        if VFFSL(SL,"timeline.prev",True): # generated from line 121, col 5
            write('     <td class="timeline_control_prev"><a href="')
            _v = VFFSL(SL,"timeline.prev",True) # '$timeline.prev' on line 122, col 49
            if _v is not None: write(_filter(_v, rawExpr='$timeline.prev')) # from line 122, col 49.
            write('"><b>')
            if False:
                _("prev")
            _v = VFFSL(SL,"_",False)("prev") # '$_("prev")' on line 122, col 68
            if _v is not None: write(_filter(_v, rawExpr='$_("prev")')) # from line 122, col 68.
            write('</b></a></td>\n')
        else: # generated from line 123, col 5
            write('     <td class="timeline_control_inactive"><b>')
            if False:
                _("prev")
            _v = VFFSL(SL,"_",False)("prev") # '$_("prev")' on line 124, col 47
            if _v is not None: write(_filter(_v, rawExpr='$_("prev")')) # from line 124, col 47.
            write('</b></td>\n')
        write('\n')
        if VFFSL(SL,"timeline.current",True): # generated from line 127, col 5
            write('     <td class="timeline_control_cur"><a href="')
            _v = VFFSL(SL,"timeline.current",True) # '$timeline.current' on line 128, col 48
            if _v is not None: write(_filter(_v, rawExpr='$timeline.current')) # from line 128, col 48.
            write('"><b>')
            if False:
                _("current")
            _v = VFFSL(SL,"_",False)("current") # '$_("current")' on line 128, col 70
            if _v is not None: write(_filter(_v, rawExpr='$_("current")')) # from line 128, col 70.
            write('</b></a></td>\n')
        else: # generated from line 129, col 5
            write('     <td class="timeline_control_cur_inactive"><b>')
            if False:
                _("current")
            _v = VFFSL(SL,"_",False)("current") # '$_("current")' on line 130, col 51
            if _v is not None: write(_filter(_v, rawExpr='$_("current")')) # from line 130, col 51.
            write('</b></td>\n')
        write('\n')
        if VFFSL(SL,"timeline.next",True): # generated from line 133, col 5
            write('     <td class="timeline_control_next"><a href="')
            _v = VFFSL(SL,"timeline.next",True) # '$timeline.next' on line 134, col 49
            if _v is not None: write(_filter(_v, rawExpr='$timeline.next')) # from line 134, col 49.
            write('"><b>')
            if False:
                _("next")
            _v = VFFSL(SL,"_",False)("next") # '$_("next")' on line 134, col 68
            if _v is not None: write(_filter(_v, rawExpr='$_("next")')) # from line 134, col 68.
            write('</b></a></td>\n')
        else : # generated from line 135, col 5
            write('     <td class="timeline_control_inactive"><b>')
            if False:
                _("next")
            _v = VFFSL(SL,"_",False)("next") # '$_("next")' on line 136, col 47
            if _v is not None: write(_filter(_v, rawExpr='$_("next")')) # from line 136, col 47.
            write('</b></td>\n')
        write('''
   </tr></table>
  </td>
 </tr>

 </table>


<table id="message_list_nav">
  <tr>
''')
        if VFFSL(SL,"nav.prev",True): # generated from line 148, col 5
            write('      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.first",True) # '$nav.first' on line 149, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.first')) # from line 149, col 52.
            write('">&lt;&lt;</a></td>\n      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.prev",True) # '$nav.prev' on line 150, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.prev')) # from line 150, col 52.
            write('">&lt;</a></td>\n')
        else: # generated from line 151, col 5
            write('      <td class="message_list_nav_button_empty">&lt;&lt;</td>\n      <td class="message_list_nav_button_empty">&lt;</td>\n')
        if VFFSL(SL,"nav.next",True): # generated from line 155, col 5
            write('      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.next",True) # '$nav.next' on line 156, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.next')) # from line 156, col 52.
            write('">&gt;</a></td>\n      <td class="message_list_nav_button"><a href="')
            _v = VFFSL(SL,"nav.last",True) # '$nav.last' on line 157, col 52
            if _v is not None: write(_filter(_v, rawExpr='$nav.last')) # from line 157, col 52.
            write('">&gt;&gt;</a></td>\n')
        else: # generated from line 158, col 5
            write('      <td class="message_list_nav_button_empty">&gt;</td>\n      <td class="message_list_nav_button_empty">&gt;&gt;</td>\n')
        write('''  </tr>
  <tr>
    <td class="message_list_nav_infos" colspan="4">
      ''')
        _v = VFFSL(SL,"nav.from",True) # '$nav.from' on line 165, col 7
        if _v is not None: write(_filter(_v, rawExpr='$nav.from')) # from line 165, col 7.
        write(' ... ')
        _v = VFFSL(SL,"nav.to",True) # '$nav.to' on line 165, col 21
        if _v is not None: write(_filter(_v, rawExpr='$nav.to')) # from line 165, col 21.
        write(' (')
        if False:
            _("total")
        _v = VFFSL(SL,"_",False)("total") # '$_("total")' on line 165, col 30
        if _v is not None: write(_filter(_v, rawExpr='$_("total")')) # from line 165, col 30.
        write(':')
        _v = VFFSL(SL,"total",True) # '$total' on line 165, col 42
        if _v is not None: write(_filter(_v, rawExpr='$total')) # from line 165, col 42.
        write(''')
    </td>
  </tr>
</table>

''')
        _filter = _orig_filter_27944379
        _orig_filter_34038948 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = _orig_filter_34038948
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''




''')
        self.main_content(trans=trans)
        write('''



''')
        self.menu_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_MessageListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(MessageListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(MessageListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(MessageListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=MessageListing()).run()


