#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka.templates.ClassicLayout import ClassicLayout
from prewikka.views.sensor import node_cmp
from prewikka.views.sensor import analyzer_cmp

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1181732074.605206
__CHEETAH_genTimestamp__ = 'Wed Jun 13 10:54:34 2007'
__CHEETAH_src__ = 'prewikka/templates/SensorListing.tmpl'
__CHEETAH_srcLastModified__ = 'Mon May 21 15:57:22 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SensorListing(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 5, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_21388411 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('\n')
        if len(VFFSL(SL,"locations",True)) > 0: # generated from line 8, col 1
            write(' <form action="?" method="post">\n <input type="hidden" name="view" value="sensor_messages_delete" />\n')
        write('''
<div id="fieldset_page">

''')
        listing = VFN(VFFSL(SL,"locations",True),"keys",False)()
        _v = VFN(VFFSL(SL,"listing",True),"sort",False)() # '$listing.sort()' on line 16, col 1
        if _v is not None: write(_filter(_v, rawExpr='$listing.sort()')) # from line 16, col 1.
        write('\n\n')
        for entry in VFFSL(SL,"listing",True): # generated from line 18, col 1
            write(' <fieldset class="fieldset_heading">\n')
            if VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["missing"] > 0 or VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["unknown"] > 0: # generated from line 20, col 3
                display = "block"
                display_tmp = "none"
                dclass = "heartbeat_analyze_sensor_status_missing"
                write('   \n   ')
                if False:
                    _("%(missing)d missing, %(unknown)d unknown of %(total)d analyzers")
                text = VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("%(missing)d missing, %(unknown)d unknown of %(total)d analyzers") % VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)])
            else: # generated from line 26, col 3
                display = "none"
                display_tmp = "block"
                dclass = "heartbeat_analyze_sensor_status_online"
                write('   ')
                if False:
                    _("All analyzers online")
                text = VFFSL(SL,"_",False)("All analyzers online")
            write('\n  <legend><b><a href="#" onclick="javascript:toggleVisibility(\'')
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 33, col 64
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 33, col 64.
            write("_tmp'); toggleVisibility('")
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 33, col 98
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 33, col 98.
            write('\'); return false;">')
            _v = VFFSL(SL,"entry",True) # '$entry' on line 33, col 125
            if _v is not None: write(_filter(_v, rawExpr='$entry')) # from line 33, col 125.
            write('</a></b></legend>\n\n   <div id="')
            _v = VFFSL(SL,"entry",True) # '${entry}' on line 35, col 13
            if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 35, col 13.
            write('_tmp" style="display: ')
            _v = VFFSL(SL,"display_tmp",True) # '$display_tmp' on line 35, col 43
            if _v is not None: write(_filter(_v, rawExpr='$display_tmp')) # from line 35, col 43.
            write('">\n    <p style="text-align: center;" class="')
            _v = VFFSL(SL,"dclass",True) # '$dclass' on line 36, col 43
            if _v is not None: write(_filter(_v, rawExpr='$dclass')) # from line 36, col 43.
            write('">')
            _v = VFFSL(SL,"text",True) # '$text' on line 36, col 52
            if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 36, col 52.
            write('''</p>
   </div>

   <div id="''')
            _v = VFFSL(SL,"entry",True) # '$entry' on line 39, col 13
            if _v is not None: write(_filter(_v, rawExpr='$entry')) # from line 39, col 13.
            write('" style="display: ')
            _v = VFFSL(SL,"display",True) # '$display' on line 39, col 37
            if _v is not None: write(_filter(_v, rawExpr='$display')) # from line 39, col 37.
            write('">\n')
            nlisting = VFN(VFFSL(SL,"locations",True)[VFFSL(SL,"entry",True)]["nodes"],"values",False)()
            write('   ')
            _v = VFN(VFFSL(SL,"nlisting",True),"sort",False)(node_cmp) # '$nlisting.sort(node_cmp)' on line 41, col 4
            if _v is not None: write(_filter(_v, rawExpr='$nlisting.sort(node_cmp)')) # from line 41, col 4.
            write('\n   \n')
            for node in VFFSL(SL,"nlisting",True): # generated from line 43, col 4
                cnt = 0
                row_classes = ("table_row_even", "table_row_odd")
                row_class = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2]
                write('\n')
                if VFFSL(SL,"node.missing",True) > 0 or VFFSL(SL,"node.unknown",True) > 0: # generated from line 48, col 3
                    display = "block"
                    dclass = "heartbeat_analyze_sensor_status_missing"
                    write('   ')
                    if False:
                        _("%(missing)d missing, %(unknown)d unknown of %(total)d analyzers")
                    text = VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("%(missing)d missing, %(unknown)d unknown of %(total)d analyzers") % VFFSL(SL,"node",True))
                else: # generated from line 52, col 3
                    display = "none"
                    write('   ')
                    if False:
                        _("All analyzers online")
                    text = VFFSL(SL,"_",False)("All analyzers online")
                    dclass = "heartbeat_analyze_sensor_status_online"
                write('''    
    <table style="width:100%; border: 1px solid black;">
     <thead style="width: 100%;">
      <tr class="''')
                _v = VFFSL(SL,"dclass",True) # '$dclass' on line 60, col 18
                if _v is not None: write(_filter(_v, rawExpr='$dclass')) # from line 60, col 18.
                write('">\n        <th>')
                _v = VFFSL(SL,"node.node_name",True) # '$node.node_name' on line 61, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.node_name')) # from line 61, col 13.
                write('</th>\n        <th>\n')
                for addr in VFFSL(SL,"node.node_addresses",True): # generated from line 63, col 10
                    write('          <a href="#" onclick="javascript:toggleVisibilityUnique(\'')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 64, col 67
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 64, col 67.
                    write('_')
                    _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 64, col 76
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 64, col 76.
                    write('_addr\'); return false;">')
                    _v = VFFSL(SL,"addr.value",True) # '$addr.value' on line 64, col 116
                    if _v is not None: write(_filter(_v, rawExpr='$addr.value')) # from line 64, col 116.
                    write('</a><br />\n          <span id="')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 65, col 21
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 65, col 21.
                    write('_')
                    _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 65, col 30
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 65, col 30.
                    write('_addr" class="popup_menu">\n           - <a href="')
                    _v = VFFSL(SL,"addr.inline_filter",True) # '$addr.inline_filter' on line 66, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$addr.inline_filter')) # from line 66, col 23.
                    write('">')
                    if False:
                        _("Filter on address")
                    _v = VFFSL(SL,"_",False)("Filter on address") # '$_("Filter on address")' on line 66, col 44
                    if _v is not None: write(_filter(_v, rawExpr='$_("Filter on address")')) # from line 66, col 44.
                    write('</a><br />\n           - <a target="')
                    _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 67, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 67, col 25.
                    write('" href="https://www.prelude-ids.com/host_details.php?host=')
                    _v = VFFSL(SL,"addr.value",True) # '$addr.value' on line 67, col 113
                    if _v is not None: write(_filter(_v, rawExpr='$addr.value')) # from line 67, col 113.
                    write('">')
                    if False:
                        _("Address information")
                    _v = VFFSL(SL,"_",False)("Address information") # '$_("Address information")' on line 67, col 126
                    if _v is not None: write(_filter(_v, rawExpr='$_("Address information")')) # from line 67, col 126.
                    write('</a><br />\n    \n')
                    for name, link in VFFSL(SL,"addr.host_commands",True): # generated from line 69, col 12
                        write('           - <a href="')
                        _v = VFFSL(SL,"link",True) # '$link' on line 70, col 23
                        if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 70, col 23.
                        write('">')
                        _v = VFFSL(SL,"name",True) # '$name' on line 70, col 30
                        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 70, col 30.
                        write('</a><br />\n')
                    write('          </span>\n')
                write('        </th>\n        <th>')
                _v = VFFSL(SL,"node.ostype",True) # '$node.ostype' on line 75, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.ostype')) # from line 75, col 13.
                write('</th>\n        <th>')
                _v = VFFSL(SL,"node.osversion",True) # '$node.osversion' on line 76, col 13
                if _v is not None: write(_filter(_v, rawExpr='$node.osversion')) # from line 76, col 13.
                write('</th>        \n        <th style="width: 150px; text-align: center;" class="')
                _v = VFFSL(SL,"dclass",True) # '$dclass' on line 77, col 62
                if _v is not None: write(_filter(_v, rawExpr='$dclass')) # from line 77, col 62.
                write('">  \n         <b><a href="#" onclick="javascript:toggleVisibility(\'')
                _v = VFFSL(SL,"entry",True) # '${entry}' on line 78, col 63
                if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 78, col 63.
                write('_')
                _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 78, col 72
                if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 78, col 72.
                write('\'); return false;">')
                _v = VFFSL(SL,"text",True) # '$text' on line 78, col 107
                if _v is not None: write(_filter(_v, rawExpr='$text')) # from line 78, col 107.
                write('''</a></b>
        </th>
      </tr>
     </thead>
    </table>
    
    <div id="''')
                _v = VFFSL(SL,"entry",True) # '${entry}' on line 84, col 14
                if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 84, col 14.
                write('_')
                _v = VFFSL(SL,"node.node_key",True) # '${node.node_key}' on line 84, col 23
                if _v is not None: write(_filter(_v, rawExpr='${node.node_key}')) # from line 84, col 23.
                write('" style="display: ')
                _v = VFFSL(SL,"display",True) # '$display' on line 84, col 57
                if _v is not None: write(_filter(_v, rawExpr='$display')) # from line 84, col 57.
                write('"> \n    <table style="width: 100%; border: 1px solid black;">\n      <tr class="')
                _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2] # '$row_classes[$cnt%2]' on line 86, col 18
                if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt%2]')) # from line 86, col 18.
                write('">\n       <th>')
                if False:
                    _("Delete")
                _v = VFFSL(SL,"_",False)("Delete") # '$_("Delete")' on line 87, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Delete")')) # from line 87, col 12.
                write('</th>\n       <th>')
                if False:
                    _("Name")
                _v = VFFSL(SL,"_",False)("Name") # '$_("Name")' on line 88, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Name")')) # from line 88, col 12.
                write('</th>\n       <th>')
                if False:
                    _("Model")
                _v = VFFSL(SL,"_",False)("Model") # '$_("Model")' on line 89, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Model")')) # from line 89, col 12.
                write('</th>\n       <th>')
                if False:
                    _("Version")
                _v = VFFSL(SL,"_",False)("Version") # '$_("Version")' on line 90, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Version")')) # from line 90, col 12.
                write('</th>\n       <th>')
                if False:
                    _("Class")
                _v = VFFSL(SL,"_",False)("Class") # '$_("Class")' on line 91, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Class")')) # from line 91, col 12.
                write('</th>\n       <th>')
                if False:
                    _("Last heartbeat")
                _v = VFFSL(SL,"_",False)("Last heartbeat") # '$_("Last heartbeat")' on line 92, col 12
                if _v is not None: write(_filter(_v, rawExpr='$_("Last heartbeat")')) # from line 92, col 12.
                write('</th>\n       <th style="text-align: center;">')
                if False:
                    _("Status")
                _v = VFFSL(SL,"_",False)("Status") # '$_("Status")' on line 93, col 40
                if _v is not None: write(_filter(_v, rawExpr='$_("Status")')) # from line 93, col 40.
                write('</th>\n      </tr>\n')
                alisting = VFFSL(SL,"node.analyzers",True)
                write('     ')
                _v = VFN(VFFSL(SL,"node.analyzers",True),"sort",False)(analyzer_cmp) # '$node.analyzers.sort(analyzer_cmp)' on line 96, col 6
                if _v is not None: write(_filter(_v, rawExpr='$node.analyzers.sort(analyzer_cmp)')) # from line 96, col 6.
                write('\n')
                for analyzer in VFFSL(SL,"node.analyzers",True): # generated from line 97, col 6
                    cnt += 1
                    write('      <tr class="')
                    _v = VFFSL(SL,"row_classes",True)[VFFSL(SL,"cnt",True)%2] # '$row_classes[$cnt%2]' on line 99, col 18
                    if _v is not None: write(_filter(_v, rawExpr='$row_classes[$cnt%2]')) # from line 99, col 18.
                    write('">\n       <td style="padding-top: 0px; padding-bottom: 0px;"><input class="checkbox" type="checkbox" name="analyzerid" value="')
                    _v = VFFSL(SL,"analyzer",True)["analyzerid"] # '$analyzer["analyzerid"]' on line 100, col 124
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["analyzerid"]')) # from line 100, col 124.
                    write('''" /></td>
       
       <td>
        <a href="#" onclick="javascript:toggleVisibilityUnique(\'''')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 103, col 65
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 103, col 65.
                    write('_')
                    _v = VFFSL(SL,"node.node_name",True) # '${node.node_name}' on line 103, col 74
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_name}')) # from line 103, col 74.
                    write('_')
                    _v = VFFSL(SL,"analyzer.analyzerid",True) # '${analyzer.analyzerid}' on line 103, col 92
                    if _v is not None: write(_filter(_v, rawExpr='${analyzer.analyzerid}')) # from line 103, col 92.
                    write('\'); return false;">')
                    _v = VFFSL(SL,"analyzer.name",True) # '$analyzer.name' on line 103, col 133
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.name')) # from line 103, col 133.
                    write('</a>\n        <span id="')
                    _v = VFFSL(SL,"entry",True) # '${entry}' on line 104, col 19
                    if _v is not None: write(_filter(_v, rawExpr='${entry}')) # from line 104, col 19.
                    write('_')
                    _v = VFFSL(SL,"node.node_name",True) # '${node.node_name}' on line 104, col 28
                    if _v is not None: write(_filter(_v, rawExpr='${node.node_name}')) # from line 104, col 28.
                    write('_')
                    _v = VFFSL(SL,"analyzer.analyzerid",True) # '${analyzer.analyzerid}' on line 104, col 46
                    if _v is not None: write(_filter(_v, rawExpr='${analyzer.analyzerid}')) # from line 104, col 46.
                    write('" class="popup_menu">\n         - <a href="')
                    _v = VFFSL(SL,"analyzer.alert_listing",True) # '$analyzer.alert_listing' on line 105, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.alert_listing')) # from line 105, col 21.
                    write('">')
                    if False:
                        _("Alert listing")
                    _v = VFFSL(SL,"_",False)("Alert listing") # '$_("Alert listing")' on line 105, col 46
                    if _v is not None: write(_filter(_v, rawExpr='$_("Alert listing")')) # from line 105, col 46.
                    write('</a><br />\n         - <a href="')
                    _v = VFFSL(SL,"analyzer.heartbeat_listing",True) # '$analyzer.heartbeat_listing' on line 106, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_listing')) # from line 106, col 21.
                    write('">')
                    if False:
                        _("Heartbeat listing")
                    _v = VFFSL(SL,"_",False)("Heartbeat listing") # '$_("Heartbeat listing")' on line 106, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeat listing")')) # from line 106, col 50.
                    write('</a><br />\n         - <a href="')
                    _v = VFFSL(SL,"analyzer.heartbeat_analyze",True) # '$analyzer.heartbeat_analyze' on line 107, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer.heartbeat_analyze')) # from line 107, col 21.
                    write('">')
                    if False:
                        _("Heartbeat analysis")
                    _v = VFFSL(SL,"_",False)("Heartbeat analysis") # '$_("Heartbeat analysis")' on line 107, col 50
                    if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeat analysis")')) # from line 107, col 50.
                    write('''</a><br />
        </span>
       </td>
       <td>''')
                    _v = VFFSL(SL,"analyzer",True)["model"] # '$analyzer["model"]' on line 110, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["model"]')) # from line 110, col 12.
                    write('</td>\n       <td>')
                    _v = VFFSL(SL,"analyzer",True)["version"] # '$analyzer["version"]' on line 111, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["version"]')) # from line 111, col 12.
                    write('</td>\n       <td>')
                    _v = VFFSL(SL,"analyzer",True)["class"] # '$analyzer["class"]' on line 112, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["class"]')) # from line 112, col 12.
                    write('</td>\n       <td>')
                    _v = VFFSL(SL,"analyzer",True)["last_heartbeat_time"] # '$analyzer["last_heartbeat_time"]' on line 113, col 12
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["last_heartbeat_time"]')) # from line 113, col 12.
                    write('</td>\n       <td class="heartbeat_analyze_sensor_status_')
                    _v = VFFSL(SL,"analyzer",True)["status"] # '$analyzer["status"]' on line 114, col 51
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["status"]')) # from line 114, col 51.
                    write('">')
                    _v = VFFSL(SL,"analyzer",True)["status_meaning"] # '$analyzer["status_meaning"]' on line 114, col 72
                    if _v is not None: write(_filter(_v, rawExpr='$analyzer["status_meaning"]')) # from line 114, col 72.
                    write('</td>\n      </tr>\n')
                write('''    </table>
    </div>
    
    <br />
''')
            write('''  </div>
 </fieldset>

<br />
''')
        write('\n')
        if len(VFFSL(SL,"locations",True)) > 0: # generated from line 128, col 1
            write('  <div style="text-align: right; vertical-align: bottom;">\n    <input class="checkbox" type="checkbox" name="alerts" /><b>')
            if False:
                _("Alerts")
            _v = VFFSL(SL,"_",False)("Alerts") # '$_("Alerts")' on line 130, col 64
            if _v is not None: write(_filter(_v, rawExpr='$_("Alerts")')) # from line 130, col 64.
            write('</b>\n    <input class="checkbox" type="checkbox" name="heartbeats" /><b>')
            if False:
                _("Heartbeats")
            _v = VFFSL(SL,"_",False)("Heartbeats") # '$_("Heartbeats")' on line 131, col 68
            if _v is not None: write(_filter(_v, rawExpr='$_("Heartbeats")')) # from line 131, col 68.
            write('</b>\n    &nbsp;<input type="submit" value="')
            if False:
                _("Delete")
            _v = VFFSL(SL,"_",False)("Delete") # '$_("Delete")' on line 132, col 39
            if _v is not None: write(_filter(_v, rawExpr='$_("Delete")')) # from line 132, col 39.
            write('" />\n  </div>\n')
        write('''
</div>
</form>

''')
        _filter = _orig_filter_21388411
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('\n')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_SensorListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(SensorListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(SensorListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SensorListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SensorListing()).run()


